<?php
/*
Plugin Name: Thank Me Later
Plugin URI: http://making-the-web.com/thank-me-later/
Description: Sends a customizable "thank you" message after (a few hours, few days, weeks) a comment has been posted. This acts a reminder of your blog and can bring "one-time" readers back
Author: Brendon Boshell
Version: 1.1
Author URI: http://making-the-web.com
*/

/*
	These are some variables that will be used through out the script
	
	They are not here for you to change. Please change options from the options page
	
*/

$_TML_Table             = $wpdb->prefix . "thankmelater"; // you should not change this value
$_TML_SentTable         = $wpdb->prefix . "thankmelater_sent"; // you should not change this value
$_TML_hasOptions        = false;
$_TML_sendafter         = false;
$_TML_giveortake        = false;
$_TML_enabled           = false;
$_TML_message_from      = false;
$_TML_message_fromemail = false;
$_TML_message_subject   = false;
$_TML_message_message   = false;
$_TML_processGroupSize  = false;
$_TML_updateInterval    = false;
$_TML_maxSend           = false;
$_TML_sendGap           = false;


function _TML_options_panel() { // This functions shows the options page to configure the plugin:

	global $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_maxSend, $_TML_sendGap;
	
	_TML_get_options();

	if(isset($_POST['Submit'])) {
	
		check_admin_referer('thank-me-later-update-options');
		
		if($_POST['_tml_slashes'] == '\\\'') { // slashes problem
			$_POST['_tml_sendafter_time']      = stripslashes($_POST['_tml_sendafter_time']);
			$_POST['_tml_sendafter_type']      = stripslashes($_POST['_tml_sendafter_type']);
			$_POST['_tml_giveortake_time']     = stripslashes($_POST['_tml_giveortake_time']);
			$_POST['_tml_giveortake_type']     = stripslashes($_POST['_tml_giveortake_type']);
			$_POST['_tml_enabled']             = stripslashes($_POST['_tml_enabled']);
			$_POST['_tml_message_from']        = stripslashes($_POST['_tml_message_from']);
			$_POST['_tml_message_fromemail']   = stripslashes($_POST['_tml_message_fromemail']);
			$_POST['_tml_message_subject']     = stripslashes($_POST['_tml_message_subject']);
			$_POST['_tml_message_message']     = stripslashes($_POST['_tml_message_message']);
			$_POST['_tml_processGroupSize']    = stripslashes($_POST['_tml_processGroupSize']);
			$_POST['_tml_updateInterval_time'] = stripslashes($_POST['_tml_updateInterval_time']);
			$_POST['_tml_updateInterval_type'] = stripslashes($_POST['_tml_updateInterval_type']);
			$_POST['_tml_sendGap_time']        = stripslashes($_POST['_tml_sendGap_time']);
			$_POST['_tml_sendGap_type']        = stripslashes($_POST['_tml_sendGap_type']);
			$_POST['_tml_maxSend']             = stripslashes($_POST['_tml_maxSend']);
		}
		
		$_TML_options = array(
						'sendafter'         => (int)($_POST['_tml_sendafter_time']     * $_POST['_tml_sendafter_type']),
						'giveortake'        => (int)($_POST['_tml_giveortake_time']    * $_POST['_tml_giveortake_type']),
						'enabled'           =>      (($_POST['_tml_enabled'] == 'true') ? 'true' : 'false'),
						'message_from'      =>       $_POST['_tml_message_from'],
						'message_fromemail' =>       $_POST['_tml_message_fromemail'],
						'message_subject'   =>       $_POST['_tml_message_subject'],
						'message_message'   =>       $_POST['_tml_message_message'],
						'processGroupSize'  => (int) $_POST['_tml_processGroupSize'],
						'updateInterval'    => (int)($_POST['_tml_updateInterval_time'] * $_POST['_tml_updateInterval_type']),
						'sendGap'           => (int)($_POST['_tml_sendGap_time']        * $_POST['_tml_sendGap_type']),
						'maxSend'           => (int)($_POST['_tml_maxSend'])
					);
					
		update_option('_tml_options', serialize($_TML_options));
		
		update_option('_tml_nextUpdate', 0); // reset next update time.
		
		_TML_get_options(); // get Updated options
		
		
	}
	
	?>
		<div class="wrap">
			<h2>Thank Me Later Configuration</h2>
			<p><strong>Thank Me Later</strong> is a plug-in which will automatically send a thank you email to readers after they post a comment. It can be set to send the message a time after the comment was posted (an hour, day, week, month, etc). It is effective as it will remind readers of their comments and gets them engaged with future discussion and your blog. Useful to attract "one-time" readers who will post one comment, and then forget about your blog.</p>
			
			<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo plugin_basename(__FILE__) ?>">
				<?php wp_nonce_field('thank-me-later-update-options'); ?>
				
				<input type="hidden" name="_tml_slashes" value="'" />
				
				<table cellspacing="7" cellpadding="5" border="0">
				
					<tr>
						<td>Enabled?</td>
						
						<td>
							<input type="checkbox" name="_tml_enabled" value="true"<?php if($_TML_enabled == 'true') { ?> checked="checked"<?php } ?> /> Yes
						</td>
					</tr>
					
					<tr>
						<td>From Name:</td>
						
						<td>
							<input size="40" type="text" name="_tml_message_from" value="<?php echo attribute_escape($_TML_message_from); ?>" /> <small>Optional</small>
						</td>
					</tr>
					
					<tr>
						<td>From Email:</td>
						
						<td>
							<input size="40" type="text" name="_tml_message_fromemail" value="<?php echo attribute_escape($_TML_message_fromemail); ?>" /> <small>Optional</small>
						</td>
					</tr>
					
					<tr>
						<td>Message Subject*:</td>
						
						<td>
							<input size="40" type="text" name="_tml_message_subject" value="<?php echo attribute_escape($_TML_message_subject); ?>" />
						</td>
					</tr>
					
					<tr>
						<td valign="top">Message*:</td>
						
						<td>
							<textarea name="_tml_message_message" cols="40" rows="12"><?php echo attribute_escape($_TML_message_message); ?></textarea> <br /><small>This message should be as personal as possible. You can use tags to refer to readers by name, and use PHP to display conditional messages.</small>
						</td>
					</tr>
					
					<tr>
						<td valign="top">Send message after:</td>
						
						<td>
							<input size="7" type="text" name="_tml_sendafter_time" value="<?php echo attribute_escape($_TML_sendafter); ?>" /><select name="_tml_sendafter_type">
							<option value="1" selected="selected">seconds</option>
							<option value="60">minutes</option>
							<option value="3600">hours</option>
							<option value="86400">days</option>
							<option value="604800">weeks</option>
						</select>, give or take <input size="7" type="text" name="_tml_giveortake_time" value="<?php echo attribute_escape($_TML_giveortake); ?>" /><select name="_tml_giveortake_type">
							<option value="1" selected="selected">seconds</option>
							<option value="60">minutes</option>
							<option value="3600">hours</option>
							<option value="86400">days</option>
							<option value="604800">weeks</option>
						</select> <small>It's best to send a message a day or two later.</small>
						</td>
					</tr>
					
					<tr>
						<td valign="top">Check queue every:</td>
						
						<td>
							<input size="7" type="text" name="_tml_updateInterval_time" value="<?php echo attribute_escape($_TML_updateInterval); ?>" /><select name="_tml_updateInterval_type">
							<option value="1" selected="selected">seconds</option>
							<option value="60">minutes</option>
							<option value="3600">hours</option>
							<option value="86400">days</option>
							<option value="604800">weeks</option>
						</select> <small>How often should we send a batch of emails?</small>
						</td>
					</tr>
					
					<tr>
						<td valign="top">Group Size:</td>
						
						<td>
							<input size="7" type="text" name="_tml_processGroupSize" value="<?php echo attribute_escape($_TML_processGroupSize); ?>" /> <small>How many records should we take from the database at any one time?</small>
						</td>
					</tr>
					
					<tr>
						<td valign="top">Max. messages to single email:</td>
						
						<td>
							<input size="7" type="text" name="_tml_maxSend" value="<?php echo attribute_escape($_TML_maxSend); ?>" /> <small>How many times should we send an email to the same email address? 0 for unlimited</small>
						</td>
					</tr>
					
					<tr>
						<td valign="top">Minimum gap between comments:</td>
						
						<td>
							Send one thank you email for one comment every <input size="7" type="text" name="_tml_sendGap_time" value="<?php echo attribute_escape($_TML_sendGap); ?>" /><select name="_tml_sendGap_type">
							<option value="1" selected="selected">seconds</option>
							<option value="60">minutes</option>
							<option value="3600">hours</option>
							<option value="86400">days</option>
							<option value="604800">weeks</option>
						</select> <small>This prevents users having many of the same email being sent at once. 14 days is a good setting.</small>
						</td>
					</tr>
					
				</table>
				
				<!-- Rules don't matter here -->
				<style type="text/css">
				
					.thankmelater_tags {
						list-style: none;
						margin: 0;
						padding: 0;
						padding-left: 30px;
					}
					
					.thankmelater_tags li {
						
					}
					.thankmelater_tags .name {
						float: left; width: 140px;
					}
				</style>
				
				<p>
					* In the subject and message fields, you can use these tags for different variables:
					<ul class="thankmelater_tags">
						<li class="name">&lt;$ID&gt;</li>
						<li>ID of the comment</li>
						<li class="name">&lt;$POST_ID&gt;</li>
						<li>ID of the post (article)</li>
						<li class="name">&lt;$AUTHOR&gt;</li>
						<li>Author's Name</li>
						<li class="name">&lt;$AUTHOR_EMAIL&gt;</li>
						<li>Author's Email Address</li>
						<li class="name">&lt;$AUTHOR_URL&gt;</li>
						<li>Author's Website URL</li>
						<li class="name">&lt;$AUTHOR_IP&gt;</li>
						<li>Author's IP Address</li>
						<li class="name">&lt;$DATE&gt;</li>
						<li>Date of the comment (as YYYY-MM-DD HH:MM:SS)</li>
						<li class="name">&lt;$DATE_GMT&gt;</li>
						<li>GMT Date of the comment (as YYYY-MM-DD HH:MM:SS)</li>
						<li class="name">&lt;$CONTENT&gt;</li>
						<li>Content of the comment (message)</li>
						<li class="name">&lt;$KARMA&gt;</li>
						<li>Undefined</li>
						<li class="name">&lt;$AGENT&gt;</li>
						<li>User's Agent String</li>
						<li class="name">&lt;$TYPE&gt;</li>
						<li>Type of comment</li>
						<li class="name">&lt;$PARENT&gt;</li>
						<li>Comment's Parent</li>
						<li class="name">&lt;$USER_ID&gt;</li>
						<li>User's ID</li>
					</ul>
				</p>
				
				<p>Any text in the form of <code><span style="color: #FF0000;">&lt;?php</span> <span style="color: #FF9900;">/* Code Here */</span> <span style="color: #FF0000;">?&gt;</span></code> will be evaluated as PHP code. To output, you must use the <code><span style="color: #006600">return</span></code> function. You can access the comment's ID via the variable <code>$comment_ID</code>. For example:</p>
				
				<ul class="thankmelater_tags">
				
						<li><code><span style="color: #FF0000;">&lt;?php</span> <span style="color: #006600">return</span> <span style="color: #CC0000;">"Your comment ID is $comment_ID"</span>; <span style="color: #FF0000;">?&gt;</span></code></li>
						
						<li><code>Thank you for your comment ("<span style="color: #FF0000;">&lt;?php</span> $comment = get_comment($comment_ID, OBJECT); <span style="color: #006600">return</span> <span style="color: #0000FF;">substr</span>($comment<span style="color: #0000FF;">-></span>comment_content, 0, 30)<span style="color: #0000FF;">.</span><span style="color: #CC0000;">"..."</span>; <span style="color: #FF0000;">?&gt;</span>") yesterday at Making the Web...</code></li>
						
						<li><code>You can find your comment at this URL: <span style="color: #FF0000;">&lt;?php</span> $comment = get_comment($comment_ID, OBJECT); <span style="color: #006600">return</span> get_permalink($comment<span style="color: #0000FF;">-></span>comment_post_ID)<span style="color: #0000FF;">.</span><span style="color: #CC0000;">"#comment-"</span><span style="color: #0000FF;">.</span>$comment_ID; <span style="color: #FF0000;">?&gt;</span></code></li>
						
					</ul>
				
				<?php /* Code Here */ ?>
				<p class="submit">
					<input type="submit" name="Submit" value="<?php _e('Save Changes'); ?>" />
				</p>
				
			</form>
			
		</div>
	<?php
}

function _TML_options() {
    if (function_exists('add_options_page')) {
		add_options_page('Thank Me Later', 'Thank Me Later', 8, plugin_basename(__FILE__), '_TML_options_panel');
	}
}

function _TML_install() {
	global $wpdb, $_TML_SentTable, $_TML_Table, $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_maxSend, $_TML_sendGap;
	echo 'hhhrewyre';
	$_TML_Table     = $_TML_Table     ? $_TML_Table     : $wpdb->prefix . "thankmelater";
	$_TML_SentTable = $_TML_SentTable ? $_TML_SentTable : $wpdb->prefix . "thankmelater_sent";
	
	delete_option('_tml_installed');
	add_option('_tml_installed','false',NULL,'no');
	
	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	
	if($wpdb->get_var("SHOW TABLES LIKE '".$_TML_Table."'") != $_TML_Table) {
		
		$sql = "CREATE TABLE ".$_TML_Table." (
						`id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
						`comment_ID` BIGINT UNSIGNED NOT NULL ,
						`date` INT UNSIGNED NOT NULL ,
						PRIMARY KEY ( `id` ) ,
						INDEX ( `date` )
					);";
	
		dbDelta($sql);
	
	}
	
	if($wpdb->get_var("SHOW TABLES LIKE '".$_TML_SentTable."'") != $_TML_SentTable) {
		
		$sql = "CREATE TABLE ".$_TML_SentTable." (
						`hash` INT NOT NULL,
						`email` TEXT NOT NULL ,
						`sent` SMALLINT UNSIGNED NOT NULL ,
						`lastcomment` INT UNSIGNED NOT NULL,
						INDEX ( `hash` )
					);";
	
		dbDelta($sql);
	
	}
	
	_TML_get_options();
	
	$_TML_options = array(
						'sendafter'         => ($_TML_sendafter === false)         ? 86400 : $_TML_sendafter,
						'giveortake'        => ($_TML_giveortake === false)        ? 3600 : $_TML_giveortake,
						'enabled'           => ($_TML_enabled === false)           ? 'true' : $_TML_enabled,
						'message_from'      => ($_TML_message_from === false)      ? get_bloginfo('name') : $_TML_message_from,
						'message_fromemail' => ($_TML_message_fromemail === false) ? '' : $_TML_message_fromemail,
						'message_subject'   => ($_TML_message_subject === false)   ? 'Thank you for your comment' : $_TML_message_subject,
						'message_message'   => ($_TML_message_message === false)   ? "Hi <\$AUTHOR>\n\nThank you for your message on Making the Web. We look forward to your future communication.\n\nYou can find your comment at this URL: <?php \$comment = get_comment(\$comment_ID, OBJECT); return get_permalink(\$comment->comment_post_ID).\"#comment-\".\$comment_ID; ?>" : $_TML_message_message,
						'processGroupSize'  => ($_TML_processGroupSize === false)  ? 100 : $_TML_processGroupSize,
						'updateInterval'    => ($_TML_updateInterval === false)    ? 1800 : $_TML_updateInterval,
						'sendGap'           => ($_TML_sendGap === false)           ? 1209600 : $_TML_sendGap,
						'maxSend'           => ($_TML_maxSend === false)           ? 0 : $_TML_maxSend,
					);
					
	delete_option('_tml_options');
	add_option('_tml_options', serialize($_TML_options), NULL, 'no');
	
	if(get_option("_tml_nextUpdate") === false) {
		delete_option("_tml_nextUpdate");
		add_option("_tml_nextUpdate", '0',NULL,'yes');
	}
	
	update_option('_tml_installed', 'true');
	
}

function _TML_uninstall() {
	
}

function _TML_get_options() {
	global $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_maxSend, $_TML_sendGap;
	
	$_TML_options = get_option('_tml_options');
	
	if(!is_array($_TML_options)) $_TML_options = unserialize($_TML_options);
	
	$_TML_sendafter         = isset($_TML_options['sendafter'])         ? $_TML_options['sendafter']         : false; 
	$_TML_giveortake        = isset($_TML_options['giveortake'])        ? $_TML_options['giveortake']        : false; 
	$_TML_enabled           = isset($_TML_options['enabled'])           ? $_TML_options['enabled']           : false; 
	$_TML_message_from      = isset($_TML_options['message_from'])      ? $_TML_options['message_from']      : false; 
	$_TML_message_fromemail = isset($_TML_options['message_fromemail']) ? $_TML_options['message_fromemail'] : false; 
	$_TML_message_subject   = isset($_TML_options['message_subject'])   ? $_TML_options['message_subject']   : false; 
	$_TML_message_message   = isset($_TML_options['message_message'])   ? $_TML_options['message_message']   : false; 
	$_TML_processGroupSize  = isset($_TML_options['processGroupSize'])  ? $_TML_options['processGroupSize']  : false; 
	$_TML_updateInterval    = isset($_TML_options['updateInterval'])    ? $_TML_options['updateInterval']    : false; 
	$_TML_maxSend           = isset($_TML_options['maxSend'])           ? $_TML_options['maxSend']           : false; 
	$_TML_sendGap           = isset($_TML_options['sendGap'])           ? $_TML_options['sendGap']           : false;
}

$_TML_CUR_ID = 0;

function _TML_eval($php) {
	global $_TML_CUR_ID;
	$php = $php[1];
	$php = '$comment_ID = '.$_TML_CUR_ID.';'.$php;
	return eval($php);
}

function _TML_parse($text, $comment) {
	
	$text = preg_replace_callback('/<\?php(.*?)\?>/', '_TML_eval', $text);
	
	// replace variables
	$text = str_replace(array('<$ID>','<$POST_ID>','<$AUTHOR>','<$AUTHOR_EMAIL>','<$AUTHOR_URL>','<$AUTHOR_IP>','<$DATE>','<$DATE_GMT>','<$CONTENT>','<$KARMA>','<$APPROVED>','<$AGENT>','<$TYPE>','<$PARENT>','<$USER_ID>'), array($comment->comment_ID, $comment->comment_post_ID, $comment->comment_author, $comment->comment_author_email, $comment->comment_author_url, $comment->comment_author_IP, $comment->comment_author_date , $comment->comment_author_date_gmt, $comment->comment_content, $comment->comment_karma, $comment->comment_approved, $comment->comment_agent, $comment->comment_type, $comment->comment_parent, $comment->user_id), $text);
	
	return $text;
}

function _TML_ShiftLeftAs32($val, $l) { /* 32 bit shift */
	$val = str_pad(decbin($val) . str_repeat(0, $l), 32, 0, STR_PAD_LEFT);
	$val = substr($val, strlen($val)-32);
	
	if($val[0] == '1')
		return bindec(substr($val, 1)) -2147483648;
		
	return bindec($val);
}

function _TML_hashint($text) {
	$hash = pack('H*', md5($text));
		
	$hash = 
		  _TML_ShiftLeftAs32(ord($hash[0]), 24)
		+ _TML_ShiftLeftAs32(ord($hash[1]), 16)
		+ _TML_ShiftLeftAs32(ord($hash[2]), 8)
		+(ord($hash[3]));
		
	return $hash;
}

function _TML_processQueue() {
	global $wpdb, $_TML_Table, $_TBL_hasOptions, $_TML_sendafter, $_TML_giveortake, $_TML_enabled, $_TML_message_from, $_TML_message_fromemail, $_TML_message_subject, $_TML_message_message, $_TML_processGroupSize, $_TML_updateInterval, $_TML_CUR_ID, $_TML_maxSend, $_TML_sendGap;

	set_time_limit(0); // Processing the queue will take a while
	
	_TML_get_options();
	
	if($_TML_enabled != 'true') return;
	
	$time = time();
	
	if($_TML_message_from && $_TML_message_fromemail)
		$from = 'From: '.$_TML_message_from.' <'.$_TML_message_fromemail.">\n";
	elseif($_TML_message_from)
		$from = 'From: '.$_TML_message_from."\n";
	elseif($_TML_message_fromemail)
		$from = 'From: '.$_TML_message_fromemail."\n";
	
	while(true) {
	
		$query = "SELECT `id`, `comment_ID`, `date` FROM $_TML_Table WHERE `date` < $time LIMIT 0, $_TML_processGroupSize";
		
		$results = $wpdb->get_results($query);
		
		if(!isset($results[0])) break; // there are no results.
		
		$deletequery = '';
		
		foreach($results as $result) {
		
			$comment = get_comment($result->comment_ID, OBJECT);
			
			$deletequery .= ','.$result->id;
			
			if($comment->comment_approved != '1') continue; // comment is not approved
			
			$_TML_CUR_ID = $comment->comment_ID;
			
			wp_mail($comment->comment_author_email, _TML_parse($_TML_message_subject, $comment), _TML_parse($_TML_message_message, $comment), $from);
		
		}
		
		$affected = $wpdb->query("DELETE FROM $_TML_Table WHERE `id` IN (".substr($deletequery, 1).")");
		if(!$affected) return; // safeguard: if we can not delete the rows, we'll be in this endless loop forever.
		
		$deletequery = '';
		
	}
	
	
	
}

function _TML_comment_post($id, $status) {
	global $wpdb, $_TML_enabled, $_TML_SentTable, $_TML_Table, $_TML_sendafter, $_TML_giveortake, $_TML_maxSend, $_TML_sendGap;
	
	_TML_get_options();
	
	if($_TML_enabled != 'true') return;
	
	$time = time();
	
	$comment = get_comment($id, OBJECT);
	
	$hash = _TML_hashint($comment->comment_author_email);
	
	$query = $wpdb->prepare("SELECT `hash`, `email`, `sent`, `lastcomment` FROM $_TML_SentTable WHERE `hash` = ".$hash." AND `email` = %s", $comment->comment_author_email);
	
	$result = $wpdb->get_row($query, OBJECT);
	
	if($result) {
		
		if($_TML_maxSend)
			if($result->sent >= $_TML_maxSend)
				return;
		if($_TML_sendGap)
			if($result->lastcomment+$_TML_sendGap > $time)
				return;
				
		$query = $wpdb->prepare("UPDATE $_TML_SentTable SET sent=sent+1, lastcomment = ".$time." WHERE `hash` = ".$hash." AND `email` = %s", $comment->comment_author_email);
	
		$wpdb->query($query);
		
	}else{
	
		$query = $wpdb->prepare("INSERT INTO $_TML_SentTable (`hash`, `email`, `sent`, `lastcomment`) VALUES (".$hash.", %s, 1, ".$time.")", $comment->comment_author_email);
	
		$wpdb->query($query);
		
	}
	
	$time += $_TML_sendafter - $_TML_giveortake;
	$time+= rand(0, $_TML_giveortake*2);
	
	$query = "INSERT INTO $_TML_Table (comment_ID, date) VALUES ($id, $time)";
	
	$result = $wpdb->query($query);
	
}

function _TML_init() {
	global $_TML_updateInterval;
	if((get_option('_tml_nextUpdate') < time()) && (get_option('_tml_nextUpdate') !== false)) {
	
		_TML_get_options();
	
		update_option('_tml_nextUpdate', time()+$_TML_updateInterval);
		
		// Note: the following will not work when using localhost.		
		wp_schedule_single_event(time(), '_TML_processQueuehook'); //run in the background
	}
}

add_action('_TML_processQueuehook', '_TML_processQueue');

add_action('admin_menu', '_TML_options', 1);
add_action('activate_'.plugin_basename(__FILE__), '_TML_install');
add_action('deactivate_'.plugin_basename(__FILE__),'_TML_uninstall');

add_action('init', '_TML_init');

add_action('comment_post', '_TML_comment_post', 10, 2);